/*

f-cpu/qdcpoc/control.c
created Wed Jul 11 02:18:29 2001 by whygee@f-cpu.org

Beware ! don't do what is written here at home !
Don't let children look, or they'll be scared to death !

(C) YG 2001 all rights reserved. you're warned !!!
read f-cpu/qdcpoc/about.txt for the details.

This file is included in f-cpu/qdcpoc/main.c

version : Thu Jul 19 00:40:05 2001
modified some stuffs, added a loopless (modulo-based
bitfield compression) zero check for writeback.
beware : i have not tested this version !!!

version : Sat Jul 21 02:27:53 2001
updated the "bit compression", found a modulo-less
version that is faster and cleaner, easier
to understand and optimize. the modulo used ints
and the modulo's result used 9 bits, but the
null_flags are u8.

version : Tue Jul 24 03:02:17 2001
modifying the Xbar to reflect the new scheduling
for immediates and reg-moves. some cleanup and
addition of the "subpart" comments. it looks
better than before now.

version : Thu Jul 26 00:10:04 2001
changing all "FIFO" with "queue", finishing the
queue routines. still cleaning.

version : Mon Jul 30 17:20:10 2001
adding the opcode LUT support.

*/


/* last stage of the pipeline : */
void fc0_cycle_writeback() {
  u64 t1,t4,t5,t6,t7;
  SMAX t2, t3;
  u8 i,j,k;

/* ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
  global inputs :
    R7write_address(*), R7write_port(*), R7write_mask(*)
  global outputs : (modified globals)
    reg_set, LSBflag, lSBflag, null_flags, NULLflag
  missing : ROP2 bypass.
   ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ */

  /* check if there is something to write : */
  if (R7write_address0 > 0) {
/* subpart 1 */

#ifndef QUICKnLAXIST
    if (R7write_address1 == R7write_address0)
      qdcpoc_error("Panic !! trying to write the same register 2x at the same time !!!", 6);
#endif

/* subpart 1.1 */
    /* update the register : */
    reg_set[R7write_address0] =
       (reg_set[R7write_address0] & ~R7write_mask0)
                 | (R7write_port0 &  R7write_mask0);
    /* in HW, this is done simply with a "write enable" pin in the FF gate */

    /* Update the flags (in parallel). The "trick" is that there is a local copy which
       is updated when the corresponding write mask/enable is set. */
    t1 = 1LL << R7write_address0; /* create the mask, it's purely a C stuff. */

/* subpart 1.2 */
    /* update LSB */
    if ((R7write_mask0 & 1)==1) {
      t2 = ~((R7write_port0 & 1)-1); /* for the LSB, 0 or -1L with nasty trick to propagate the LSB */
      LSBflag = (LSBflag & ~t1) | (t2 & t1);
    }

/* subpart 1.3 */
    /* update the MSB */
    if ((R7write_mask0 >>63)!=0) {
      t3 = (SMAX)R7write_port0 >> 63;      /* for the MSB, 0 or -1L through sign propagation */
      MSBflag = (MSBflag & ~t1) | (t3 & t1);
    }

/* subpart 1.4 */
    /* update the null bits.
       some background : the register set can be updated in selected parts. The 0 flag
       reflects the status of ALL the bits in every register, but the write ports
       provide partial values. We have to keep the rest of the partial values
       "cached" (because we don't want to read the register) and we update a fraction
       of the bits. What the decoder sees is the OR of all partial 8-inputs ORs (negated).
    */
    i = null_flags[R7write_address0];

    /* "loopless" way of doing 8 parallel 8-bit ORs : */
    t4 = R7write_mask0, t6 = R7write_port0;
    t5 = t4 >> 1,       t7 = t6 >> 1;
    t4 |= t5,           t6 |= t7;
    t5 = t4 >> 2,       t7 = t6 >> 1;
    t4 |= t5,           t6 |= t7;
    t5 = t4 >> 4,       t7 = t6 >> 1;
    t4 |= t5,           t6 |= t7;
    t4 &= 0x0101010101010101LL, t6 &= 0x0101010101010101LL;
    /* now we have either 0x01 or 0x00 in each byte, if the
       corresponding byte is cleared or not. and now, we
       compress the scattered bits into a single byte : */
    t5 = t4 >> (32+4),  t7 = t6 >> (32+4);
    t4 |= t5,           t6 |= t7;
    t5 = t4 >> (16+2),  t7 = t6 >> (16+2);
    t4 |= t5,           t6 |= t7;
    t5 = t4 >> (8+1),   t7 = t6 >> (8+1);
    k = t4 | t5,        j = t6 | t7;   /* type cast to u8, implicit masking of the MSBs */
    i = (i & ~k) | (j & k);

    null_flags[R7write_address0] = i;
    /* 8-input OR of the partial results : */
    t4 = 0;
    if (i == 0)
      t4 = -1LL;
    NULLflag = (NULLflag & ~t1) | (t4 & t1);

    /* This code is ugly but it shows that we can keep the flags up to date
       without even reading the register set. */

  }

  /* same as above, but without checking the collision
     (symmetry helps) and the comments are removed. */
  if (R7write_address1 > 0) {
/* subpart 2 */

/* subpart 2.1 */
    reg_set[R7write_address1] =
      (reg_set[R7write_address1] & ~R7write_mask1)
                | (R7write_port1 &  R7write_mask1);

    t1 = 1LL << R7write_address1;

/* subpart 2.2 */
    if ((R7write_mask1 & 1)==1) {
      t2 = ~((R7write_port1 & 1)-1);
      LSBflag = (LSBflag & ~t1) | (t2 & t1);
    }

/* subpart 2.3 */
    if ((R7write_mask1 & (1LL<<63))==1) {
      t3 = (SMAX)R7write_port1 >> 63;
      MSBflag = (MSBflag & ~t1) | (t3 & t1);
    }

/* subpart 2.4 */
    i = null_flags[R7write_address1];

    /* "loopless" way for updating the ZERO partial flags : */
    t4 = R7write_mask1, t6 = R7write_port1;
    t5 = t4 >> 1,       t7 = t6 >> 1;
    t4 |= t5,           t6 |= t7;
    t5 = t4 >> 2,       t7 = t6 >> 1;
    t4 |= t5,           t6 |= t7;
    t5 = t4 >> 4,       t7 = t6 >> 1;
    t4 |= t5,           t6 |= t7;
    t4 &= 0x0101010101010101LL, t6 &= 0x0101010101010101LL;
    t5 = t4 >> (32+4),  t7 = t6 >> (32+4);
    t4 |= t5,           t6 |= t7;
    t5 = t4 >> (16+2),  t7 = t6 >> (16+2);
    t4 |= t5,           t6 |= t7;
    t5 = t4 >> (8+1),   t7 = t6 >> (8+1);
    k = t4 | t5,        j = t6 | t7;
    i = (i & ~k) | (j & k);
    null_flags[R7write_address1] = i;

    /* 8-input OR of the partial results : */
    t4 = 0;
    if (i == 0)
      t4 = -1LL;
    NULLflag = (NULLflag & ~t1) | (t4 & t1);
  }
}


/* this part is mainly a big mux */
void fc0_cycle_Xbar_write() {
  int Xbar_write_address0, Xbar_write_address1;

/* ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
  global inputs :
    sched_queue[0](.*), Xbar_read_port(*) and all EU outputs.
  global outputs : (modified globals)
    R7write_address(*), R7write_port(*), R7write_mask(*)
  missing : N/A
  remarks :
   * the actual mux is not yet completely defined. Some entries can be removed in the future.
   * the mux choices should be "enum"erated.
   ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ */

/* subpart 1 */
  /* get the scheduling information from the FIFO queue : */
  R7write_address0 = sched_queue[0].write0;
  R7write_address1 = sched_queue[0].write1;
  R7write_mask0 = mask_LUT[sched_queue[0].mask0];
  R7write_mask1 = mask_LUT[sched_queue[0].mask1]; /* 2x lookup but that's only in C. */
  Xbar_write_address0 = sched_queue[0].unit0;
  Xbar_write_address1 = sched_queue[0].unit1;

/* subpart 2 */
  /* Warning ! we should use enums here... */
  if (Xbar_write_address0 > 0) {
    switch(Xbar_write_address0) {
      case 1: R7write_port0 = Xbar_read_port0; break;  /* immediates */
      case 2: R7write_port0 = Xbar_read_port1; break;  /* reg2reg */
      case 4: R7write_port0 = Xbar_ROP2_port; break;
      case 5: R7write_port0 = Xbar_ASU_port0; break;  /* normal ASU output to Write Bus #0 + 2W case */
	/* other EU outputs come here */
      default : qdcpoc_error("Error in Case", 7);
    }
  }

/* subpart 3 */
  if (Xbar_write_address1 > 0) {
    switch(Xbar_write_address1) {
      case 1: R7write_port1 = Xbar_read_port0; break;  /* immediates */
      case 2: R7write_port1 = Xbar_read_port1; break;  /* reg2reg */
      case 4: R7write_port1 = Xbar_ROP2_port; break;
      case 5: R7write_port1 = Xbar_ASU_port0; break;  /* normal ASU output to Write Bus #1 */
      case 6: R7write_port1 = Xbar_ASU_port1; break;  /* 2W case */
	/* other EU outputs come here */
      default : qdcpoc_error("Error in Case", 8);
    }
  }
}

void fc0_cycle_Xbar_read() {
  int i;

/* ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
  global inputs : ROP2_function, Xbar_read_address(*), R7write_port(*)
    
  global outputs : (modified globals)
    ROP2_function_bit(*), Xbar_ROP2_mode, Xbar_EU_ROP2, Xbar_read_port(*)

  missing : N/A
   ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ */

/* subpart 1 */
  /* bufferize the ROP2 signals : */
  i=ROP2_function_LUT[ROP2_function]; /* table lookup : 3 bits->4 bits */
  ROP2_function_bit0 = ~((i & 1) -1);   /* bit propagation */
  ROP2_function_bit1 = ~(((i >> 1) & 1) -1);
  ROP2_function_bit2 = ~(((i >> 2) & 1) -1);
  ROP2_function_bit3 = ~(((i >> 3) & 1) -1);
  Xbar_ROP2_mode = ROP2_mode;
  Xbar_EU_ROP2 = EU_ROP2;

  /* buffer for all other EU signals here. */

/* subpart 2 */

  /* decide if we "issue" the instruction. */
  /* An instruction is considered as "issued" if it is inserted in the queue. */

  /* "issue" the instruction by inserting it in the scheduler queue. */

/* subpart 3 */
  /* Xbar : big multiplex */
  /* Warning ! (2) enums... */
  if (Xbar_read_address0 > 0) {
    switch(Xbar_read_address0) {
      case 1: Xbar_read_port0 = R7read_port0; break;  /* normal read */
      case 2: Xbar_read_port0 = DEC_imm_port; break;  /* read an immediate data */

      case 4: Xbar_read_port0 = R7write_port0; break; /* bypass through R7 write port 0 */
      case 5: Xbar_read_port0 = R7write_port1; break; /* bypass through R7 write port 1 */
      default : qdcpoc_error("Error in Case", 9);
    }
  }

/* subpart 4 */
    /* cut, paste and rename : */
  if (Xbar_read_address1 > 0) {
    switch(Xbar_read_address1) {
      case 1: Xbar_read_port1 = R7read_port1; break;  /* normal read */

      case 3: Xbar_read_port1 = DEC_NIP; break;  /* used by LOOPENTRY & LOADADDRI, check coherency with the manual */
      case 4: Xbar_read_port1 = R7write_port0; break; /* bypass R7 through write port 0 */
      case 5: Xbar_read_port1 = R7write_port1; break; /* bypass R7 through write port 1 */
      default : qdcpoc_error("Error in Case", 10);
    }
  }

/* subpart 5 */
  if (Xbar_read_address2 > 0) {
    switch(Xbar_read_address2) {
      case 1: Xbar_read_port2 = R7read_port2; break;  /* normal read */
      case 4: Xbar_read_port2 = R7write_port0; break; /* bypass through R7 write port 0 */
      case 5: Xbar_read_port2 = R7write_port1; break; /* bypass through R7 write port 1 */
      default : qdcpoc_error("Error in Case", 11);
    }
  }
}


/* you want a headache ? You get a headache. read below. */
void fc0_cycle_decode() {
  int i, t, u,
      R7read_address0,
      R7read_address1,
      R7read_address2;
  UMAX condition;

/* ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
  global inputs : instruction_buffer
    
  global outputs : (modified globals)
    
  missing : N/A
   ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ */

/* subpart 0 : all the fields are preextracted. this is a transparent aliasing
   from the coding point of view, no "operation" is performed. */

 /* extract the register fields from the instructions */
  R7read_address0 = (instruction_buffer >> 14 ) & 63;
  R7read_address1 = (instruction_buffer >> 20 ) & 63;
  R7read_address2 = (instruction_buffer >> 26 ) & 63;
  RW2 = R7read_address2 ^ 1;  /* this field is used as destination in 3R1W or second dest in 2R2W */

  /* other fields */



  condition_code = (instruction_buffer >> 11) & 3;
  current_opcode = instruction_buffer & 0xFF;
  ROP2_function = (instruction_buffer >> 5) & 7;
  ROP2_mode = (instruction_buffer >> 12) & 3;
  imm16 = (instruction_buffer >> 10) & 0xFFFF ;
  imm8 = (instruction_buffer >> 12) & 0xFF ;
  loadcons_shift = (instruction_buffer >> 6) & 15;

  current_opcode = instruction_buffer & 0xFF; /* is the mask necessary ? */
  DEC_CIP = FETCH_CIP;
  DEC_CIP = FETCH_NIP;


/* subpart 1 */
  /* register read */
  R7read_port0 = reg_set[R7read_address0];
  R7read_port1 = reg_set[R7read_address1];
  R7read_port2 = reg_set[R7read_address2];


/* subpart 2 */
  /* latency and necessary ressources for the opcode : */
  opcode_type = opcode_LUT[current_opcode];

  /* special case 1 (before it is integrated in the LUT) */
  if (((current_opcode & ~7) == OP_ROP2) && (ROP2_mode == ROP2_MUX_MODE)) {
    opcode_type.need_src2 = 1;
    opcode_type.need_rw2  = 1;
  }

  /* special case 2 (before it is integrated in the LUT) */
  if ((current_opcode & ~) == OP_ROP2) {
    if ((current_opcode & ~3) == OP_LOADCONSX) {
      /* handle the sign extension for the immediate part */
    }
  }

  valid_opcode =
    opcode_type.latency_zero
  | opcode_type.latency_direct
  | opcode_type.latency_cycle_1
  | opcode_type.latency_cycle_2
  | opcode_type.latency_multiply
  | opcode_type.latency_idiv;
  /* if no bit is set, this means
     that the opcode is not supported. */

  if (valid_opcode == 0)
    qdcpoc_error("unknown opcode", 15);

  /* at this point, we must
      * trigger the SRB 
      * save the IP
      * fetch the trap handling code
   */



/* subpart N : */
  /* immediate data : */


/* subpart 2 */
  /* decode the conditions : */
  switch(condition_code) {
    case 0: condition = NULLflag;
    case 1: condition = MSBflag;
    case 2: condition = LSBflag;
/* default: condition = 0; ??? validity is checked elsewhere */
  }

  /* missing : ROP2 bypass */
  condition_true = ((~condition >> R7read_address1)
                   ^ (instruction_buffer >> 10)) & 1; /* negation of the condition */

/* subpart 3 */
/* check register availability :
   the queue shift is merged with the comparison in the following loop.
   however, sched_queue[0] is considered as "ready" so
   we don't check it and the first stage is out of the loop.
 */

/* subpart 3.1 : compare and shift of the queue's bottom */

/* subpart 3.1.1 */
   /* bypass condition : (we test toward sched_queue[1]
      because it will become sched_queue[0] at the next cycle) */
  register0_on_Xbar0 = (sched_queue[1].write0 ^ R7read_address0);
  register1_on_Xbar0 = (sched_queue[1].write0 ^ R7read_address1);
  register2_on_Xbar0 = (sched_queue[1].write0 ^ R7read_address2);
/*      RW2_on_Xbar0 = (sched_queue[1].write0 ^ RW2);  can be reduced with R7read_address2 */
  register0_on_Xbar1 = (sched_queue[1].write1 ^ R7read_address0);
  register1_on_Xbar1 = (sched_queue[1].write1 ^ R7read_address1);
  register2_on_Xbar1 = (sched_queue[1].write1 ^ R7read_address2);
/*      RW2_on_Xbar1 = (sched_queue[1].write1 ^ RW2);  can be reduced with R7read_address2 */

/* subpart 3.1.2 */
  /* shift the bottom of the queue */
  sched_queue[0] = sched_queue[1];

  /* some decisions about the bypass must be taken here. */

/* subpart 3.2 */
  /* start the compare and shift for the whole queue */
  for (i=2; i<(DEPTH_QUEUE-1); i++) {
/* subpart 3.2.1 */
    /* comparisons */
    if ((sched_queue[i].write0 == R7read_address0)
      ||(sched_queue[i].write1 == R7read_address0))
      register0_ready = 0;
    if ((sched_queue[i].write0 == R7read_address1)
      ||(sched_queue[i].write1 == R7read_address1))
      register1_ready = 0;
    /* one simplified version : */
    t = sched_queue[i].write0 ^ R7read_address2,
    u = sched_queue[i].write1 ^ R7read_address2;
    if ((t==0x00)||(u==0x00))
      register2_ready = 0;
    if ((t==0x01)||(u==0x01))
      RW2_ready = 0;
    /* this code understands that RW2 = R7read_address2 ^1
       so we spare almost a couple comparisons (around 20%) */

/* nb : we are forced to check the availability of the
  destination register because we handle multiple sizes
  and a partial write could cause wonderful worries if
  it was performed at the wrong time.  */

/* subpart 3.2.2 */
    /* QUEUE shift */
    sched_queue[i-1] = sched_queue[i];

  }

/* subpart 3.3 */
  /* last stage : include the results from the DIV unit. */
  if (IDIV_complete != 0) {

/* subpart 3.3.1 */
    /* the usual check : */
    if ((IDIV_write_destination == R7read_address0)
     || (IDIV_write_destination_bis == R7read_address0))
      register0_ready = 0;
    if ((IDIV_write_destination == R7read_address1)
     || (IDIV_write_destination_bis == R7read_address1))
      register1_ready = 0;
    if ((IDIV_write_destination == R7read_address2)
     || (IDIV_write_destination_bis == R7read_address2))
      register2_ready = 0;
    if ((IDIV_write_destination == RW2)
     || (IDIV_write_destination_bis == RW2))
      RW2_ready = 0;
    /* xor simplification forgotten here, sorry */

/* subpart 3.3.2 */
    /* run the countdown */
    IDIV_counter --;
    if (IDIV_counter == 0) { /* time is up ! */
      IDIV_complete = 0;

/* subpart 3.3.3 */
      /* insert the register numbers in the queue : */
      sched_queue[DEPTH_QUEUE-1].write0 = IDIV_write_destination;
      sched_queue[DEPTH_QUEUE-1].unit0  = IDIV_unit0;
      sched_queue[DEPTH_QUEUE-1].mask0  = IDIV_write_mask0;
      sched_queue[DEPTH_QUEUE-1].busy0  = 1;
      sched_queue[DEPTH_QUEUE-1].write1 = IDIV_write_destination_bis;
      sched_queue[DEPTH_QUEUE-1].unit1  = IDIV_unit1;
      sched_queue[DEPTH_QUEUE-1].mask1  = IDIV_write_mask1;
      sched_queue[DEPTH_QUEUE-1].busy0  = 1;
    }
  }
  else {
/* subpart 3.3.4 */
    /* nothing yet, except that the high part of the queue must be cleared. */
    memset(&sched_queue[DEPTH_QUEUE-1],0,sizeof(t_queue_entry));
  }



  /* insert here the pointer comparisons */

}


/* This is the "lightweight" version before the memory subsystem
   is implemeted. it's going to change soon ! */
void fc0_cycle_fetcher() {

/* ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
  global inputs : the instruction buffer
    
  global outputs : (modified globals)
    instruction_buffer, FETCH_NIP, FETCH_CIP
  missing : a lot !
   ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ */

  if (get_next_instruction) {
    if (FETCH_CIP >= fetcher_buffer_size) {
      printf("\nEnd of program reached (pipeline flush not yet implemented)\n");
      exit(12);
    }
    get_next_instruction = 0;

    /* endian-proof reading of the instruction buffer : */
    instruction_buffer  = fetcher_buffer[FETCH_CIP ++];
    instruction_buffer |= fetcher_buffer[FETCH_CIP ++] << 8;
    instruction_buffer |= fetcher_buffer[FETCH_CIP ++] << 16;
    instruction_buffer |= fetcher_buffer[FETCH_CIP ++] << 24;
    FETCH_NIP+=4;
  }
}
