/*

f-cpu/opcodes.h
created Sat Jul 14 23:26:36 2001 by whygee@f-cpu.org

Beware ! don't do what is written here at home !
Don't let children look, or they'll be scared to death !

(C) YG all rights reserved. you're warned !!!
read f-cpu/qdcpoc/about.txt for the details.

This file contains the definition of the opcodes'
values, reflecting the most recent work. ie:
the ROP2 opcodes incorporate the function flags
in the opcode field. This is not stated in the
existing versions of the F-CPU manual.


********************WARNING!************************
All the #define are subject to changes.
They operate on 8-bit values that may be contiguous
(and must, in some cases). The #defines will be
optimized and reorganised later. Don't rely on their
values !!!
****************************************************

**** update Tue Jul 17 02:52:31 2001 by YG : ****

This file is included in f-cpu/qdcpoc/main.c
and f-cpu/ygasm/ygasm.c so there is only one
instance of the file. It only contains #defines
and it can be reused in other software as well
(and even in VHDL, i guess, using cpp).

This is an attempt at doing a proof of concept,
this might not comply with the F-CPU Manual
and contain errors. This is preliminary, do
not rely on this version for the actual values.

*/


/* these ones will be changed if needed,
   but the direct mode MUST remain 0 because
   it is the default behaviour. */
#define ROP2_DIRECT_MODE  0
#define ROP2_AND_MODE     1
#define ROP2_OR_MODE      2
#define ROP2_MUX_MODE     3


#define OP_NOP     0   /* do nothing. */

#define OP_MOV     1   /* move and cmove, with a different opcode */

#define FUNCTION_AND     (0)
#define FUNCTION_ANDN    (1)
#define FUNCTION_XOR     (2)
#define FUNCTION_OR      (3)
#define FUNCTION_NOR     (4)
#define FUNCTION_XNOR    (5)
#define FUNCTION_ORN     (6)
#define FUNCTION_NAND    (7)


#define OP_ROP2    8   /* reserving a 3-bit field => 8 opcodes */
 /* MUX and combine overlap this 8-opcode field */
#define OP_AND     (OP_ROP2 + FUNCTION_AND)
#define OP_ANDN    (OP_ROP2 + FUNCTION_ANDN)
#define OP_XOR     (OP_ROP2 + FUNCTION_XOR)
#define OP_OR      (OP_ROP2 + FUNCTION_OR)
#define OP_NOR     (OP_ROP2 + FUNCTION_NOR)
#define OP_XNOR    (OP_ROP2 + FUNCTION_XNOR)
#define OP_ORN     (OP_ROP2 + FUNCTION_ORN)
#define OP_NAND    (OP_ROP2 + FUNCTION_NAND)

#define OP_ROP2I   (OP_ROP2 + 128)
/* imm8 eats the useful bits so we can't encode MUX or combine */
#define OP_ANDI    (OP_ROP2I + FUNCTION_AND)
#define OP_ANDNI   (OP_ROP2I + FUNCTION_ANDN)
#define OP_XORI    (OP_ROP2I + FUNCTION_XOR)
#define OP_ORI     (OP_ROP2I + FUNCTION_OR)
#define OP_NORI    (OP_ROP2I + FUNCTION_NOR)
#define OP_XNORI   (OP_ROP2I + FUNCTION_XNOR)
#define OP_ORNI    (OP_ROP2I + FUNCTION_ORN)
#define OP_NANDI   (OP_ROP2I + FUNCTION_NAND)


/* the 2 opcodes require a 4-bit shift field,
   the 2 LSB are used. We need 8 opcodes for these 2 : */
#define OP_LOADCONS    16
#define OP_LOADCONSX   (OP_LOADCONS + 4)
